/* eslint-disable no-return-assign */
import Vue from 'vue'
import Router from 'vue-router'
import config from '../config'
Vue.use(Router)

function getConfigRouters () {
  // 分页面加载路由 避免router.js过大
  let cache = {}
  let routers = []// 所有的路由配置数组
  function importAll (r) {
    r.keys().forEach((key) => {
      routers.push(r(key).default)
      return cache[key] = r(key)
    })
  }
  importAll(require.context('../views/', true, /\.router\.js$/))
  return routers
}

// 配置路由
let routers = getConfigRouters()
const router = new Router({
  base: `/${config.baseUrl}/${config.url}/`,
  mode: 'history',
  routes: [
    ...routers,
    {
      path: '**',
      redirect: ''
    }
  ]
})

router.beforeEach((to, from, next) => {
  next()
})

export default router
