import { order } from '@/http'

// 获取订单
const GET_ORDERS = 'GET_ORDERS'

// 获取单个订单
const GET_ORDER = 'GET_ORDER'

// 订单总数
const TOTAL_ORDERS = 'TOTAL_ORDERS'

// 物流信息
const GET_EXPRESS = 'GET_EXPRESS'

const state = {
  orders: [],
  order: {},
  express: [],
  total: 0
}

const actions = {
  getOrders ({
    commit, dispatch
  }, parmas) {
    return order.getOrders(parmas).then((res) => {
      const orders = res.data.page.result
      const total = res.data.page.totalCount
      commit(GET_ORDERS, orders)
      dispatch('getOrdersTotal', total)
    })
  },
  getOrdersTotal ({commit}, total) {
    commit(TOTAL_ORDERS, total)
  },
  getOrder ({commit, dispatch}, id) {
    return order.getOrderById(id).then(res => {
      const order = res.data.order
      // orderStatus === '3' && returnStatus !== '6'
      if (`${order.orderStatus}` === '3' && `${order.returnStatus}` !== '6') {
        dispatch('getExpress', {
          logisticsCode: order.logisticsCode,
          logisticsNo: order.logisticsNo
        })
      }
      commit(GET_ORDER, order)
    })
  },
  getExpress ({
    commit, dispatch
  }, parmas) {
    return order.getExpress(parmas).then((res) => {
      let express = []
      const data = JSON.parse(res.data)
      if (`${data.code}` === '500') {
        express.push({
          context: data.message
          // ftime: new Date().getTime()
        })
      } else {
        express = data.data
      }
      commit(GET_EXPRESS, express)
    })
  },

  updateOrderRemark ({
    commit, dispatch
  }, parmas) {
    return order.updateOrderRemark(parmas)
  },

  updateOrderLogisticsInfo ({
    commit, dispatch
  }, parmas) {
    return order.updateOrderLogisticsInfo(parmas)
  }
}

const getters = {
  getOrders (state) {
    return state.orders
  },
  getOrdersTotal (state) {
    return state.total
  },
  getOrder (state) {
    return state.order
  },
  getExpress (state) {
    return state.express
  }
}

const mutations = {
  [GET_ORDERS] (state, orders) {
    state.orders = orders
  },
  [TOTAL_ORDERS] (state, total) {
    state.total = total
  },
  [GET_ORDER] (state, order) {
    state.order = order
  },
  [GET_EXPRESS] (state, express) {
    state.express = express
  }
}

export default {
  state,
  mutations,
  actions,
  getters
}
