import { orderConfig } from '@/http'

// 保存下单配置
// const SAVE_OR_UPDATE = 'saveOrUpdate'

// 获取下单配置
const GET_ENTITY_BY_ID = 'getEntityById'

const state = {
  detail: {
    id: '',
    inventoryLimitQuantity: '',
    sendCouponFlag: '',
    couponCode: '',
    inventoryLimitFlag: ''
  }
}

const actions = {
  saveOrUpdate ({
    commit, dispatch
  }, parmas) {
    return orderConfig.saveOrUpdate(parmas)
  },

  getEntityById ({commit, dispatch}, id = 1) {
    return orderConfig.getEntityById(id).then(res => {
      const orderConfig = res.data.data
      commit(GET_ENTITY_BY_ID, orderConfig)
      return Promise.resolve(res)
    })
  }
}

const getters = {
  orderConfig (state) {
    return state.detail
  }
}

const mutations = {
  [GET_ENTITY_BY_ID] (state, orderConfig) {
    state.detail = { ...orderConfig }
  }
}

export default {
  state,
  mutations,
  actions,
  getters
}
