import { returnOrder } from '@/http'

// 获取退货订单
const GET_RETURN_ORDERS = 'GET_TETURN_ORDERS'

// 获取单个退货订单
const GET_RETURN_ORDER = 'GET_RETURN_ORDER'

// 订单总数
const TOTAL_TETURN_ORDER = 'TOTAL_TETURN_ORDER'

const state = {
  returnOrders: [],
  detail: {},
  returnTotal: 0
}

const actions = {
  getReturnOrders ({
    commit, dispatch
  }, parmas) {
    return returnOrder.getReturnOrders(parmas).then((res) => {
      const orders = res.data.page.result
      const total = res.data.page.totalCount
      commit(GET_RETURN_ORDERS, orders)
      dispatch('getReturnOrdersTotal', total)
    })
  },
  getReturnOrdersTotal ({commit}, total) {
    commit(TOTAL_TETURN_ORDER, total)
  },
  getReturnOrder ({commit}, id) {
    return returnOrder.getReturnOrderById(id).then(res => {
      const orderReturn = res.data.orderReturn
      const order = res.data.order
      commit('GET_ORDER', order)
      commit(GET_RETURN_ORDER, orderReturn)
    })
  },
  saveOrderReturn ({commit}, parmas) {
    return returnOrder.saveOrderReturn(parmas)
  },
  updateStatus ({commit}, parmas) {
    // const state = {
    //   2: '审核通过',
    //   3: '驳回退货',
    //   7: '确认退货',
    //   4: '取消退货',
    //   5: '确认收货'
    // }
    // const status = parmas.status
    return returnOrder.updateStatus(parmas).then(res => {
      console.log(res)
      if (`${res.data.code}` === '0') {
        return Promise.resolve({
          data: {
            message: `操作成功`
          }})
      } else {
        return Promise.resolve({
          data: {
            message: `操作失败`
          }})
      }
    })
  },
  payReturn ({commit}, parmas) {
    return returnOrder.payReturn(parmas).then(res => {
      if (`${res.data.code}` === '0') {
        return Promise.resolve({
          data: {
            message: `退款成功`
          }})
      } else {
        return Promise.resolve({
          data: {
            message: `退款失败`
          }})
      }
    })
  }
}

const getters = {
  getReturnOrders (state) {
    return state.returnOrders
  },
  getReturnOrdersTotal (state) {
    return state.returnTotal
  },
  getReturnOrder (state) {
    return state.detail
  }
}

const mutations = {
  [GET_RETURN_ORDERS] (state, orders) {
    state.returnOrders = [...orders]
  },
  [TOTAL_TETURN_ORDER] (state, total) {
    state.returnTotal = total
  },
  [GET_RETURN_ORDER] (state, orderReturn) {
    state.detail = orderReturn
  }
}

export default {
  state,
  mutations,
  actions,
  getters
}
