import * as types from './mutations_types.js'
import { user } from '@/http'
export default {
  login ({
    commit,
    dispatch
  }, userInfo) {
    return user.login(userInfo)
      .then((res) => {
        if (res.data.code === 0) {
          dispatch('updateUserInfo', userInfo)
          return Promise.resolve(res)
        } else {
          return Promise.resolve({
            data: {
              message: '登陆失败'
            }})
        }
      })
  },
  updateUserInfo ({commit}, userInfo) {
    commit(types.UPDATE_USERINFO, userInfo)
  }
}
